﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ExtensionMethodsAndValueTypes {

	struct Point {
		public int X;
		public int Y;
	}

	static class PointExtensions {
		public static void Print(this Point p) {
			Console.WriteLine($"Point(X = {p.X}, Y = {p.Y})");
		}

		public static void Reset(this Point p) {
			p.X = 0;
			p.Y = 0;
		}
	}

	class Program {
		static void Main(string[] args) {
			{
				Point p;
				p.X = 11;
				p.Y = 22;

				p.Print();
				p.Reset();
				p.Print();
			}

			//
			Console.WriteLine();
			//

			{
				OtherPoint p;
				p.X = 11;
				p.Y = 22;

				p.Print();

				p.Reset();

				p.Print();
			}
		}
	}

	struct OtherPoint {
		public int X;
		public int Y;

		public void Print() {
			Console.WriteLine($"OtherPoint(X = {X}, Y = {Y})");
		}

		public void Reset() {
			X = 0;
			Y = 0;
		}
	}

}
